## ros-indigo-robot-calibration 0.5.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(robot_calibration)

if (CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif()

find_package(Boost REQUIRED system thread)

find_library(tinyxml_library tinyxml)
if (tinyxml_library)
  message (STATUS "Looking for libtinyxml - found")
  set(tinyxml_LIBRARIES ${tinyxml_library})
endif ()
find_path(tinyxml_include_dirs NAMES tinyxml.h PATH_SUFFIXES tinyxml)
if (NOT tinyxml_include_dirs)
   message (STATUS "Looking for tinyxml/tinyxml.hpp or tinyxml/tinyxml.h - not found.")
endif ()

find_package(orocos_kdl)
find_package(Ceres REQUIRED)
find_package(catkin REQUIRED
  COMPONENTS
    actionlib
    camera_calibration_parsers
    cv_bridge
    geometry_msgs
    kdl_parser
    moveit_msgs
    nav_msgs
    robot_calibration_msgs
    rosbag
    roscpp
    sensor_msgs
    std_msgs
    tf
    tf2_geometry_msgs
    tf2_ros
)

catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    actionlib
    camera_calibration_parsers
    cv_bridge
    geometry_msgs
    kdl_parser
    moveit_msgs
    nav_msgs
    robot_calibration_msgs
    rosbag
    roscpp
    sensor_msgs
    std_msgs
    tf
    tf2_geometry_msgs
    tf2_ros
  DEPENDS
    Boost
    Ceres
    orocos_kdl
  LIBRARIES
    robot_calibration
)

include_directories(include ${Boost_INCLUDE_DIRS}
                            ${catkin_INCLUDE_DIRS}
                            ${CERES_INCLUDES}
                            ${orocos_kdl_INCLUDE_DIRS})
link_directories(${orocos_kdl_LIBRARY_DIRS}) # this is a hack, will eventually be unneeded once orocos-kdl is fixed

add_executable(calibrate_base src/calibrate_base.cpp)
target_link_libraries(calibrate_base ${Boost_LIBRARIES}
                                     ${catkin_LIBRARIES})

add_library(robot_calibration src/calibration_offset_parser.cpp
                              src/chain_manager.cpp
                              src/checkerboard_finder.cpp
                              src/feature_finder.cpp
                              src/led_finder.cpp
                              src/ground_plane_finder.cpp
                              src/models.cpp
                              src/plane_finder.cpp
                              src/optimization_params.cpp
                              src/optimizer.cpp)
target_link_libraries(robot_calibration ${Boost_LIBRARIES}
                                        ${catkin_LIBRARIES}
                                        ${CERES_LIBRARIES}
                                        ${tinyxml_LIBRARIES}
                                        ${orocos_kdl_LIBRARIES})
add_dependencies(robot_calibration robot_calibration_msgs_gencpp)

add_executable(calibrate src/calibrate.cpp)
target_link_libraries(calibrate robot_calibration
                                ${Boost_LIBRARIES}
                                ${catkin_LIBRARIES}
                                ${CERES_LIBRARIES}
                                ${tinyxml_LIBRARIES}
                                ${orocos_kdl_LIBRARIES})
add_dependencies(calibrate robot_calibration)

add_subdirectory(test)

install(DIRECTORY include/ DESTINATION include)

install(TARGETS calibrate calibrate_base robot_calibration
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

=== test/CMakeLists.txt ===
find_package(rostest REQUIRED)

catkin_add_gtest(calibration_offset_parser_tests calibration_offset_parser_tests.cpp)
target_link_libraries(calibration_offset_parser_tests robot_calibration
                                                      ${Boost_LIBRARIES}
                                                      ${catkin_LIBRARIES}
                                                      ${orocos_kdl_LIBRARIES}
                                                      ${tinyxml_LIBRARIES})

catkin_add_gtest(rotation_tests rotation_tests.cpp)
target_link_libraries(rotation_tests robot_calibration
                                     ${Boost_LIBRARIES}
                                     ${catkin_LIBRARIES}
                                     ${CERES_LIBRARIES}
                                     ${orocos_kdl_LIBRARIES})

add_executable(chain_manager_tests chain_manager_tests.cpp)
add_dependencies(tests chain_manager_tests)
target_link_libraries(chain_manager_tests robot_calibration
                                          ${Boost_LIBRARIES}
                                          ${catkin_LIBRARIES}
                                          ${GTEST_LIBRARIES})

add_executable(error_block_tests error_block_tests.cpp)
add_dependencies(tests error_block_tests)
target_link_libraries(error_block_tests robot_calibration
                                        ${Boost_LIBRARIES}
                                        ${catkin_LIBRARIES}
                                        ${CERES_LIBRARIES}
                                        ${GTEST_LIBRARIES}
                                        ${orocos_kdl_LIBRARIES})

add_executable(optimization_param_tests optimization_param_tests.cpp)
add_dependencies(tests optimization_param_tests)
target_link_libraries(optimization_param_tests robot_calibration
                                               ${Boost_LIBRARIES}
                                               ${catkin_LIBRARIES}
                                               ${GTEST_LIBRARIES})

add_rostest(chain_manager_tests.test)
add_rostest(optimization_param_tests.test)
add_rostest(error_block_tests.test)

=== debian/changelog ===
ros-indigo-robot-calibration (0.5.4-0trusty) trusty; urgency=high

  * only add observations when complete
  * Adds plane calibration
  * minor style fixes, remove outdated comments
  * fix warning (#28 <https://github.com/mikeferguson/robot_calibration/issues/28>)
  * pick correct sensor in each error block
  * use proper indices for multiple finders
  * fix: don't append observations if finder has failed
  * Contributors: Martin Günther, Michael Ferguson, Niharika Arora

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Sat, 20 Jan 2018 08:00:00 -0000

ros-indigo-robot-calibration (0.5.3-0trusty) trusty; urgency=high

  * add support for multiple finders in a given pose
  * add support for ground plane calibration
  * add parameter for camera_info_topic in depth camera capture module
  * Contributors: Michael Ferguson, Niharika Arora

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Mon, 18 Jul 2016 07:00:00 -0000

ros-indigo-robot-calibration (0.5.2-0trusty) trusty; urgency=high

  * remove dependency on PCL
  * cleanup naming of member variables
  * fix centroid refinement, fixes #20 <https://github.com/mikeferguson/robot_calibration/issues/20>
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Fri, 03 Jul 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.5.1-0trusty) trusty; urgency=high

  * store calibration output in unique file name
  * better memory management in optimizer
  * parameterize sensor names in finders
  * checkerboard finder working on fetch
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Wed, 01 Jul 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.5.0-0trusty) trusty; urgency=high

  * add new CaptureConfig message for setting up samples
  * update optimizer to handle new types of error blocks
  * cleanup how we use the depth camera manager
  * refactor how feature finders are loaded
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Tue, 23 Jun 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.4.1-0trusty) trusty; urgency=high

  * check distance to expected pose in tracker process()
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Wed, 17 Jun 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.4.0-0trusty) trusty; urgency=high

  * fix for multiple joint_state publishers, roll back async spinner changes
  * output tracker status as image
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Sun, 07 Jun 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.3.1-0trusty) trusty; urgency=high

  * start async spinner earlier
  * update how we sleep for better data capture
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Thu, 23 Apr 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.3.0-0trusty) trusty; urgency=high

  * process all callbacks in async spinner
  * make waitForCloud consistent between feature detectors
  * remove all calls to spinOnce in feature detectors, chain management
  * exit if not ros::ok(), fixes #12 <https://github.com/mikeferguson/robot_calibration/issues/12>
  * do not capture if move failed, fixes #14 <https://github.com/mikeferguson/robot_calibration/issues/14>
  * publish point cloud for checkerboard detector
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Wed, 22 Apr 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.2.2-0trusty) trusty; urgency=high

  * add support for velocity scaling factor
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Sun, 12 Apr 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.2.1-0trusty) trusty; urgency=high

  * fix uninitialized variable
  * test files should not use .launch extension
  * fix error_block_test, closes #11 <https://github.com/mikeferguson/robot_calibration/issues/11>
  * fix issue with capture stalling
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Sun, 05 Apr 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.2.0-0trusty) trusty; urgency=high

  * enforce internal consistency between led features
  * remove opencv window, add cloud in message option
  * update how max error is handled
  * extend messages to support multiple sensors
  * implement ExtendedCameraInfo
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Mon, 16 Mar 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.1.2-0trusty) trusty; urgency=high

  * fix a number of warning
  * enable use of moveit for planning between poses
  * handle multiple joint_states publisher
  * update checkerboard_finder config
  * refactor led finder to use lots of parameters
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mferguson@fetchrobotics.com>  Sun, 15 Mar 2015 07:00:00 -0000

ros-indigo-robot-calibration (0.1.1-0trusty) trusty; urgency=high

  * first release
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Thu, 05 Mar 2015 08:00:00 -0000

=== debian/control ===
Source: ros-indigo-robot-calibration
Section: misc
Priority: extra
Maintainer: Michael Ferguson <mferguson@fetchrobotics.com>
Build-Depends: debhelper (>= 9.0.0), libceres-dev, libgflags-dev, libprotobuf-dev, libprotoc-dev, libsuitesparse-dev, protobuf-compiler, ros-indigo-actionlib, ros-indigo-camera-calibration-parsers, ros-indigo-catkin, ros-indigo-control-msgs, ros-indigo-cv-bridge, ros-indigo-geometry-msgs, ros-indigo-kdl-parser, ros-indigo-moveit-msgs, ros-indigo-nav-msgs, ros-indigo-orocos-kdl, ros-indigo-robot-calibration-msgs, ros-indigo-rosbag, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-tf, ros-indigo-tf2-geometry-msgs, ros-indigo-tf2-ros
Homepage: http://ros.org/wiki/robot_calibration
Standards-Version: 3.9.2

Package: ros-indigo-robot-calibration
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, libprotobuf-dev, libprotoc-dev, libsuitesparse-dev, protobuf-compiler, ros-indigo-actionlib, ros-indigo-camera-calibration-parsers, ros-indigo-control-msgs, ros-indigo-cv-bridge, ros-indigo-geometry-msgs, ros-indigo-kdl-parser, ros-indigo-moveit-msgs, ros-indigo-nav-msgs, ros-indigo-orocos-kdl, ros-indigo-robot-calibration-msgs, ros-indigo-rosbag, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-tf, ros-indigo-tf2-geometry-msgs, ros-indigo-tf2-ros
Description: Calibrate a Robot

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-robot-calibration//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
